SystemOrganization addCategory: #ImageFamilyTree!

Object subclass: #ImageFamilyTreeJudge
	instanceVariableNames: 'stream1 stream2 shorterStream longerStream binarySearch differBegin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudge classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:21'!
fileNamed: fileName1 fileNamed: fileName2

	|instance|
	instance := ImageFamilyTreeJudge new.
	instance stream1: (FileStream readOnlyFileNamed: fileName1).
	instance stream2: (FileStream readOnlyFileNamed: fileName2).
	^instance! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 21:49'!
binarySearch

	^binarySearch! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 20:56'!
decideShortStreamAndLongStream

	stream1 size > stream2 size
		ifTrue: [ shorterStream := stream2. longerStream := stream1 ]
		ifFalse: [ shorterStream := stream1. longerStream := stream2 ]. 
! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:12'!
judgeResult

	self decideShortStreamAndLongStream.
	self makeBinarySearch.
	
	self streamsAreIdentical
		ifTrue: [ ^IdenticalJRIFT new ].
	
	differBegin := binarySearch solve.
	
	^shorterStream size - 1 = differBegin
		ifTrue: [
			(shorterStream == stream1)
				ifTrue: [AncestorJRIFT new ancestor: 1; descendant: 2]
				ifFalse: [AncestorJRIFT new ancestor: 2; descendant: 1] ]
		ifFalse: [
			ShareCommonAncestorJRIFT differenceStart: binarySearch root x + 2 stream1: stream1 stream2: stream2 ]
	! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/21/2010 22:36'!
longerStream

	^longerStream! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:00'!
makeBinarySearch
			
	binarySearch := BinarySearcherForIntegerToBoolean new.
	binarySearch left: 0.
	binarySearch right: shorterStream size.
	binarySearch equation: [:pos| 
		shorterStream position: pos.
		longerStream position: pos.
		shorterStream peek = longerStream peek ].! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/21/2010 22:36'!
shorterStream

	^shorterStream! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:55'!
stream1

	^stream1! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream1: aReadStream 

	stream1 := aReadStream! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:56'!
stream2

	^stream2! !

!ImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:42'!
stream2: aReadStream 

	stream2 := aReadStream! !

!ImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/20/2010 21:02'!
streamsAreIdentical

	^shorterStream size = longerStream size 
		and: [(binarySearch value: shorterStream size) = 1] ! !

Object subclass: #JudgeResultIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #AncestorJRIFT
	instanceVariableNames: 'ancestor descendant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:50'!
ancestor

	^ancestor! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:51'!
ancestor: anInteger

	ancestor := anInteger! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:53'!
descendant

	^descendant! !

!AncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 16:54'!
descendant: anInteger

	descendant := anInteger! !

!AncestorJRIFT methodsFor: 'testing' stamp: 'hjo 11/21/2010 22:39'!
verifyJudge: anImageFamilyTreeJudge 

	| s1 s2 |
	s1 := anImageFamilyTreeJudge stream1 reset.
	s2 := anImageFamilyTreeJudge stream2 reset.
	ancestor = 1 ifTrue: [
			^s1 contents = (s2 next: s1 size)
		].
	ancestor = 2 ifTrue: [
			^s2 contents = (s1 next: s2 size)
		].
	self error: 'wtf'! !

JudgeResultIFT subclass: #IdenticalJRIFT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

JudgeResultIFT subclass: #ShareCommonAncestorJRIFT
	instanceVariableNames: 'differenceStart difference1 difference2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ShareCommonAncestorJRIFT classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:38'!
differenceStart: anInteger stream1: stream1 stream2: stream2

	| instance |
	instance := ShareCommonAncestorJRIFT new.
	instance differenceStart: anInteger.
	stream1 position: instance differenceStart-1.
	instance difference1: stream1 upToEnd.
	stream2 position: instance differenceStart-1.		
	instance difference2: stream2 upToEnd.
	^instance! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:22'!
difference1

	^difference1! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:24'!
difference1: aByteString 

	difference1 := aByteString ! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/20/2010 17:23'!
difference2

	^difference2! !

!ShareCommonAncestorJRIFT methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:24'!
difference2: aByteString 

	difference2 := aByteString ! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 19:11'!
differenceStart

	^differenceStart! !

!ShareCommonAncestorJRIFT methodsFor: 'accessing' stamp: 'hjo 11/14/2010 19:12'!
differenceStart: aSmallInteger 

	differenceStart := aSmallInteger ! !

!ShareCommonAncestorJRIFT methodsFor: 'testing' stamp: 'hjo 11/20/2010 18:56'!
verifyJudge: anImageFamilyTreeJudge 

	"can be very slow"
	| stream1 stream2 |
	stream1 := anImageFamilyTreeJudge stream1 reset.
	stream2 := anImageFamilyTreeJudge stream2 reset.
	[stream1 atEnd not and: [stream2 atEnd not]] whileTrue: [stream1 next = stream2 next ifFalse: [^(Array with: false with: stream1 position)]].
	^true! !

Object subclass: #NaiveImageFamilyTreeJudge
	instanceVariableNames: 'stream1 stream2 shorterStream longerStream differBegin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!NaiveImageFamilyTreeJudge classSide methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
fileNamed: fileName1 fileNamed: fileName2

	|instance|
	instance := NaiveImageFamilyTreeJudge new.
	instance stream1: (FileStream readOnlyFileNamed: fileName1).
	instance stream2: (FileStream readOnlyFileNamed: fileName2).
	^instance! !

!NaiveImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/25/2010 14:47'!
decideShortStreamAndLongStream

	stream1 size > stream2 size
		ifTrue: [ shorterStream := stream2. longerStream := stream1 ]
		ifFalse: [ shorterStream := stream1. longerStream := stream2 ]. 
! !

!NaiveImageFamilyTreeJudge methodsFor: 'testing' stamp: 'hjo 11/25/2010 17:45'!
judgeResult

	self decideShortStreamAndLongStream.
	longerStream reset.
	shorterStream reset.
	[shorterStream atEnd] whileFalse: [shorterStream next = longerStream next ifFalse: [^ShareCommonAncestorJRIFT differenceStart: shorterStream position stream1: stream1 stream2: stream2]].
	^longerStream size = shorterStream size 
		ifTrue: [ IdenticalJRIFT new]
		ifFalse: [(shorterStream == stream1)
				ifTrue: [AncestorJRIFT new ancestor: 1; descendant: 2]
				ifFalse: [AncestorJRIFT new ancestor: 2; descendant: 1]].! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
longerStream

	^longerStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
shorterStream

	^shorterStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream1

	^stream1! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream1: aReadStream 

	stream1 := aReadStream! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream2

	^stream2! !

!NaiveImageFamilyTreeJudge methodsFor: 'accessing' stamp: 'hjo 11/25/2010 14:47'!
stream2: aReadStream 

	stream2 := aReadStream! !

TestCase subclass: #ImageFamilyTreeJudgeTest
	instanceVariableNames: 'stream1 stream2 judge result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:49'!
test1IsAncestorOf2

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 1.
	self assert: result descendant = 2.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:50'!
test2IsAncestorOf1

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 2.
	self assert: result descendant = 1.! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/14/2010 16:35'!
testIdentical

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: IdenticalJRIFT).! !

!ImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/20/2010 17:32'!
testShareCommonAncestor

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Pluto' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Mars' readStream.

	judge := ImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: ShareCommonAncestorJRIFT).
	self assert: result differenceStart = 218.
	self assert: result difference1 = 'Pluto'.
	self assert: result difference2 = 'Mars'.! !

TestCase subclass: #NaiveImageFamilyTreeJudgeTest
	instanceVariableNames: 'stream1 stream2 judge result'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageFamilyTree'!

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:47'!
test1IsAncestorOf2

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 1.
	self assert: result descendant = 2.! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
test2IsAncestorOf1

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: AncestorJRIFT).
	self assert: result ancestor = 2.
	self assert: result descendant = 1.! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
testIdentical

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Roughly two-thirds the size of Pluto, Sedna is hypothetically large enough to be rounded by its own gravity, and thus would qualify as a dwarf planet under current definitions. However, its distance makes determining its shape difficult.' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	self assert: (judge judgeResult isKindOf: IdenticalJRIFT).! !

!NaiveImageFamilyTreeJudgeTest methodsFor: 'as yet unclassified' stamp: 'hjo 11/25/2010 14:48'!
testShareCommonAncestor

	stream1 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Pluto' readStream.

	stream2 := '90377 Sedna is a trans-Neptunian object currently about three times as far from the Sun as Neptune. For the majority of its orbit it is the most distant known object in the Solar System other than long-period comets. Mars' readStream.

	judge := NaiveImageFamilyTreeJudge new.
	judge stream1: stream1.
	judge stream2: stream2.
	result := judge judgeResult.
	self assert: (result isKindOf: ShareCommonAncestorJRIFT).
	self assert: result differenceStart = 218.
	self assert: result difference1 = 'Pluto'.
	self assert: result difference2 = 'Mars'.! !
